#ifndef ACLFS_H
#define ACLFS_H

#include <sys/stat.h>
#include <limits.h>

enum ACL_CMD{
	ACL_OPEN,
	ACL_STAT,
	ACL_LSTAT,
	ACL_OPENDIR,
	ACL_UNLINK,
	ACL_RENAME,
	ACL_MKDIR,
	ACL_RMDIR,
	ACL_MKNOD,
	ACL_LINK,
	ACL_SYMLINK,
	ACL_CHMOD,
	ACL_CHOWN,
	ACL_LCHOWN,
	ACL_CHDIR,
	ACL_UTIMES,
	ACL_ACCESS,
	ACL_RELOADACL,		// Tell the aclfsd to forget the cached ..acl
						// file for a directory
	ACL_RELOADCONF,		// Reread /etc/aclfsd.conf
	ACL_READLINK,
	ACL_EUIDACCESS,
};

struct ACL_REQUEST_BASE {
	ACL_CMD cmd;
	int mode;
	int perm;
};

class ACL_REQUEST: public ACL_REQUEST_BASE {
public:
	char paths[2*PATH_MAX];
};

enum ACL_STATUS {
	ACL_STATUS_FAIL,		// The request failed
	ACL_STATUS_OK,			// The request succeed, no special value
							// returned
	ACL_STATUS_HANDLE,		// A file handle was transmited
	ACL_STATUS_STAT,		// struc stat was sent
	ACL_STATUS_DATA,		// Receiving some data
};

struct ACL_REPLY {
	ACL_STATUS status;
	int errcode;
	int len;
};

class ACL_REPLY_DATA: public ACL_REPLY {
public:
	char data[32000];
};

#define ACLFS_SOCKET "/.aclfs.s"

#include "aclfs.p"

#endif

