#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <dirent.h>
#include <limits.h>
#include <unistd.h>
#include "dispatch.h"

/*
	Make sure the cdrom is mounted
*/
static void domount()
{
	FILE *fin = fopen ("/proc/mounts","r");
	if (fin != NULL){
		bool is_mounted = false;
		char buf[2*PATH_MAX];
		while (fgets(buf,sizeof(buf)-1,fin)!=NULL){
			char dev[PATH_MAX],dir[PATH_MAX],stuff[PATH_MAX];
			if (sscanf (buf,"%s %s %s",dev,dir,stuff)>=2
				&& strcmp(dir,"/cdrom")==0){
				is_mounted = true;
				break;
			}
		}
		fclose (fin);
		if (!is_mounted) system ("mount /cdrom");
	}
}

static int checkmount (const char *path)
{
	// Check mount is itself opening file. The open is trapped in
	// netaudio.cc and itself call checkmount. So we protect against
	// reentrancy. This is simpler then forcing function below to
	// to use lower level function.
	int ret = -1;
	static bool checkmounting = false;
	if (!checkmounting){
		checkmounting = true;
		if (strcmp(path,"/cdrom")==0
			|| strncmp(path,"/cdrom/",7)==0){
			domount();
			ret = 0;
		}else{
			const char *curpath = _dispatch_getcwd();
			if (curpath[0] == '/'
				&& curpath[1] == '\0'){
				if (strcmp(path,"cdrom")==0
					|| strncmp(path,"cdrom/",6)==0){
					domount();
					ret = 0;
				}
			}
		}
		checkmounting = false;
	}
	return ret;
}

static AUTOMOUNT p={
	NULL,
	checkmount,
	NULL,			// afterchdir
};

static REGISTER_AUTOMOUNT register_autom (p);

