#pragma implementation
#include <unistd.h>
#include <string.h>
#include "bufinput.h"

PUBLIC BUFINPUT::BUFINPUT(int _fd)
{
	nb = 0;
	fd = _fd;
}

PUBLIC int BUFINPUT::fill ()
{
	int len = ::read (fd,buf+nb,sizeof(buf)-nb);
	if (len > 0) nb += len;
	return len;
}

PUBLIC BUFINPUT_REPLY::BUFINPUT_REPLY (int _fd)
	: BUFINPUT (_fd)
{
}

PUBLIC int BUFINPUT_REPLY::read (LITE_REPLY_DATA &rep)
{
	int ret = -1;
	if (nb >= (int)sizeof(LITE_REPLY)){ 
		LITE_REPLY_DATA *p = (LITE_REPLY_DATA*)buf;
		int lenrep = sizeof(LITE_REPLY)+p->len;
		if (nb >= lenrep){
			memcpy (&rep,buf,lenrep);
			ret = lenrep;
			if (nb > lenrep){
				nb -= lenrep;
				memmove (buf,buf+lenrep,nb);
			}else{
				nb = 0;
			}
		}
		
	}
	return ret;
}

/*
	Read and wait until a full request is received
*/
PUBLIC int BUFINPUT_REPLY::readblock (LITE_REPLY_DATA &req)
{
	int ret = -1;
	while (1){
		fill();
		if (nb == 0) break;
		int n = read (req);
		if (n > 0){
			ret = n;
			break;
		}
	}
	return ret;
}

PUBLIC BUFINPUT_REQUEST::BUFINPUT_REQUEST (int _fd)
	: BUFINPUT (_fd)
{
}

PUBLIC int BUFINPUT_REQUEST::read (LITE_REQUEST_DATA &rep)
{
	int ret = -1;
	if (nb >= (int)sizeof(LITE_REQUEST)){ 
		LITE_REQUEST_DATA *p = (LITE_REQUEST_DATA*)buf;
		int lenrep = sizeof(LITE_REQUEST)+p->len;
		if (nb >= lenrep){
			memcpy (&rep,buf,lenrep);
			ret = lenrep;
			if (nb > lenrep){
				nb -= lenrep;
				memmove (buf,buf+lenrep,nb);
			}else{
				nb = 0;
			}
		}
		
	}
	return ret;
}

/*
	Read and wait until a full request is received
*/
PUBLIC int BUFINPUT_REQUEST::readblock (LITE_REQUEST_DATA &req)
{
	int ret = -1;
	while (1){
		fill();
		if (nb == 0) break;
		int n = read (req);
		if (n > 0){
			ret = n;
			break;
		}
	}
	return ret;
}

